codeseg		segment
		assume	cs:codeseg, ds:codeseg
		org	100h
glocke		proc	far
start:   	jmp	short loc_6
		db	90h
int_4Ah_entry	proc	far
		pusha					; Save all regs
		mov	ah,2
		int	1Ah				; Real time clock   ah=func 02h
							;  read clock cx=hrs/min, dh=sec
		mov	ah,7
		int	1Ah				; Real time clock   ah=func 07h
							;  clear alarm
		cmp	dh,1
		je	loc_1				; Jump if equal
		mov	dh,1
		mov	ah,6
		int	1Ah				; Real time clock   ah=func 06h
							;  set alarm cx=hrs/min, dh=sec
		mov	al,0B6h
		out	43h,al				; port 43h, 8253 wrt timr mode
		mov	ax,34DEh
		mov	dx,12h
		mov	bx,370h
		div	bx				; ax,dx rem=dx:ax/reg
		out	42h,al				; port 42h, 8253 timer 2 spkr
		mov	al,ah
		out	42h,al				; port 42h, 8253 timer 2 spkr
		in	al,61h				; port 61h, 8255 port B, read
		or	al,3
		out	61h,al				; port 61h, 8255 B - spkr, etc
		mov	dx,1
		jmp	short loc_5
		db	90h
loc_1:							;  xref 6A02:010F
		in	al,61h				; port 61h, 8255 port B, read
		and	al,0FCh
		out	61h,al				; port 61h, 8255 B - spkr, etc
		mov	dh,0
		mov	al,cl
		add	al,15h
		daa					; Decimal adjust
		cmp	al,60h				; '`'
		jne	loc_3				; Jump if not equal
		mov	cl,0
		mov	al,ch
		inc	al
		daa					; Decimal adjust
		cmp	al,24h				; '$'
		jne	loc_2				; Jump if not equal
		mov	al,0
loc_2:							;  xref 6A02:0152
		mov	ch,al
		jmp	short loc_4
		db	90h
loc_3:							;  xref 6A02:0147
		mov	cl,al
loc_4:							;  xref 6A02:0158
		mov	ah,6
		int	1Ah				; Real time clock   ah=func 06h
							;  set alarm cx=hrs/min, dh=sec
loc_5:							;  xref 6A02:0135
		popa					; Restore all regs
		iret					; Interrupt return
int_4Ah_entry	endp

data_1		db	'', 3, 1, 'J%!', 7, '', 1Ah, ''	;  xref 6A02:01AD, 01B0


		db	2, '', 1Ah, '', 0, '', 15h, 'r'

		db	'&0r', 1Ch, 'Er', 12h, '', 0


		db	'', 27h, '<$'

		db	75h, 2, 0B0h, 0
loc_7:
		mov	ch,al
		jmp	short loc_11
		db	90h
loc_8:
		mov	cl,45h				; 'E'
		jmp	short loc_11
		db	90h
loc_9:
		mov	cl,30h				; '0'
		jmp	short loc_11
		db	90h
loc_10:
		mov	cl,15h
loc_11:							;  xref 6A02:0193, 0198, 019D
		mov	ah,6
		int	1Ah				; Real time clock   ah=func 06h
							;  set alarm cx=hrs/min, dh=sec
		mov	dx,offset data_2		; (6A02:01B2=0Dh)
		mov	ah,9
		int	21h				; DOS Services  ah=function 09h
							;  display char string at ds:dx
		mov	dx,offset data_1		; (6A02:0163=0BAh)
		int	27h				; Terminate & stay resident
data_2		db	0Dh, 0Ah, '    Glockenschlag ist '	;  xref 6A02:01A6, 01AB
		db	'resident', 0Dh, 0Ah, '(c) Floria'
		db	'n Schreck 1991 (nur fr ATs)', 0Dh
		db	0Ah, 0Dh, 0Ah, '$'
glocke		endp
codeseg		ends
		end	start

